#pragma once
#include "resource.h"
#include "afxwin.h"
#include "afxcmn.h"

enum CameraZoomType {
  eCameraZoomDistance = 0,
  eCameraZoomFOV = 1
};

class CameraControl : public CDialog
{
DECLARE_DYNAMIC(CameraControl)

public:
  CameraControl(CWnd* pParent = NULL);   // standard constructor
  virtual ~CameraControl();

  enum { IDD = IDD_CAMERA_CONTROL };

  void SetCameras(Camera* pMainViewCamera, Camera* pZoomViewCamera);
protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  virtual BOOL OnInitDialog();

  DECLARE_MESSAGE_MAP()
private:
  Camera* m_pMainViewCamera;
  Camera* m_pZoomViewCamera;

  SliderCtrlWithEcho m_CameraSlider;
  CameraZoomType     m_CameraZoomType;

  BOOL m_bMoveEye;
  BOOL m_bShowCamera;
  BOOL m_bCameraRail;
public:
  
  afx_msg void OnBnClickedCheckShowCamera();
  afx_msg void OnBnClickedCheckCameraRail();
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg void OnBnClickedFovZoom();
  afx_msg void OnBnClickedDistanceZoom();
  afx_msg void OnBnClickedCheckMoveEye();
};