#pragma once
#include "resource.h"
#include "afxcmn.h"
#include "SceneTreeDialog.h"
#include "CameraControl.h"
#include "LightControl.h"
#include "ClassExampleViewport.h"
#include "InteractiveMeshControl.h"
#include "FileTextureControl.h"
#include "FogControl.h"
#include "afxwin.h"

class ClassExampleDlg : public CDialog
{
public:
  ClassExampleDlg(CWnd* pParent = NULL);

  enum { IDD = IDD_CLASSEXAMPLE_MAIN };

protected:
  virtual void DoDataExchange(CDataExchange* pDX);

protected:
  HICON m_hIcon;

  // Generated message map functions
  virtual BOOL OnInitDialog();
  afx_msg void OnPaint();
  afx_msg HCURSOR OnQueryDragIcon();
  DECLARE_MESSAGE_MAP()

private:
  void InitializeCameras();

  SceneTreeDialog    m_SceneTreeControl;
  CameraControl      m_CameraControl;
  LightControl       m_LightControl; 
  InteractiveMeshControl m_InteractiveMeshControl;
  FileTextureControl m_FileTextureControl;
  FogControl         m_FogControl;

  UIWindow              m_MainUIWindow;
  ClassExampleViewport  m_MainViewport;
  
  UIWindow              m_CornerUIWindow;
  ClassExampleViewport  m_CornerViewport;

  afx_msg void OnTimer(UINT nIDEvent);
  afx_msg void OnBnClickedResetWorld();

public:
  BOOL m_ShowCameraControl;
  BOOL m_ShowLightControl;
  BOOL m_ShowFogControl;
  BOOL m_MoveTiger;
  afx_msg void OnBnClickedFlyTiger();
  afx_msg void OnBnClickedShowCameralControl();
  afx_msg void OnBnClickedShowLightControl();
  afx_msg void OnBnClickedShowFogControl();
};
