#include "stdafx.h"
#include "ClassExampleViewport.h"
#include "World.h"

#ifdef _DEBUG
  #define new DEBUG_NEW
#endif

ClassExampleViewport::ClassExampleViewport()
: m_pOtherViewportCamera(NULL)
{
}

void ClassExampleViewport::DrawToDevice()
{ 
  if (m_pD3DDevice == NULL) return;

  // The first thing: Set up transform ...
  {
    // 1. Set up object to world to be identity for now
    D3DXMATRIX obj2world;
    D3DXMatrixIdentity(&obj2world);
    m_pD3DDevice->SetTransform(D3DTS_WORLD, &obj2world);
  }

  // allow the camera to set up view and projection
  m_Camera.DefineViewAndProjection(GetAspectRatio(), m_pD3DDevice);

  // Now get ready to draw ...
  m_pD3DDevice->Clear(0,  // number of rectangles, 0 means the entire area
                NULL,                 // rectangles to be cleared, NULL means the entire area
                D3DCLEAR_TARGET|      // clear target (color) 
                D3DCLEAR_ZBUFFER,     // and clear z-buffer
                m_BackgroundColor,    // new color to clear to
                1.0f,                 // new Z values to clear to
                0);                   // new Stencil buffer values to clear to 
              // for now we are NOT using stencil buffer yet

  m_pD3DDevice->BeginScene();
  {
    //allow the camera to draw itslf
    if(m_pOtherViewportCamera)
    {
          if(theWorld.IsMainCameraVisible()) m_pOtherViewportCamera->Draw();
          if(theWorld.IsMainCameraRailVisible()) m_pOtherViewportCamera->DrawRailRepresentation(m_pD3DDevice);
    }
    theWorld.DrawWorld();
  }
  m_pD3DDevice->EndScene();
  m_pD3DDevice->Present(NULL, NULL, NULL, NULL);
}

void ClassExampleViewport::SetOtherCamera(Camera* pCamera)
{
  m_pOtherViewportCamera = pCamera;
}