#include "StdAfx.h"
#include "ClassExampleViewport.h"
#include "World.h"

#ifdef _DEBUG
  #define new DEBUG_NEW
#endif

void ClassExampleViewport::OnMouseButton(bool down, unsigned int nFlags, int x, int y)
{
  if (!down) return;
 
  if(nFlags & MK_LBUTTON)
  {
    EchoToStatusArea("Begin Rotating the camera");
    m_Camera.BeginMouseRotate(x,y);
  }
  else if(nFlags & MK_MBUTTON)
  {
    CString msg;
    msg.Format("Begin Tracking Point(%d %d)", x, y);
    EchoToStatusArea(msg);
    m_Camera.BeginMouseTracking(x,y);
  }
  else if(nFlags & MK_RBUTTON)
  {
    CString msg;
    msg.Format("Begin Zooming: Point(%d %d)", x, y);
    EchoToStatusArea(msg);
    // We are only going to pay attention to the x-movement
    m_Camera.BeginMouseZoom(x);
	}
}

void ClassExampleViewport::OnMouseMove(unsigned int nFlags, int x, int y)
{
  if(nFlags & MK_LBUTTON)
  {
    EchoToStatusArea("Rotating the camera");
    m_Camera.MouseRotate(x,y);
  }
  else if(nFlags & MK_MBUTTON)
  {
    EchoToStatusArea("Tracking the camera");
    m_Camera.MouseTrack(x,y);
  }
  else if(nFlags & MK_RBUTTON)
  {
    EchoToStatusArea("Zooming the camera");
    m_Camera.MouseZoom(x, true);
	}
}