#pragma once


// FileTextureControl dialog
class FileTextureControl : public CDialog
{
	DECLARE_DYNAMIC(FileTextureControl)

public:
	FileTextureControl(CWnd* pParent = NULL);   // standard constructor
	virtual ~FileTextureControl();

  void SetFileTextuers(int index);
  void SetViewports(D3DViewport *v1, D3DViewport *v2) { m_V1 = v1; m_V2 = v2; }

// Dialog Data
	enum { IDD = IDD_TEXTURE_CONTROL };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  virtual BOOL OnInitDialog(); 

  
  void TextureSetFilterType();
  void TextureSetAddressMode();
  void TextureSetControl();

  D3DViewport *m_V1, *m_V2;
  FileTexture *m_F1, *m_F2;
  int         m_UVAddressMode;
  int         m_MinMagFilterMode;

	DECLARE_MESSAGE_MAP()
public:
  SliderCtrlWithEcho m_TexRotate;
  SliderCtrlWithEcho m_TexTransX;
  SliderCtrlWithEcho m_TexTransY;
  SliderCtrlWithEcho m_TexScaleX;
  SliderCtrlWithEcho m_TexScaleY;

  afx_msg void OnBnClickedTexU();
  afx_msg void OnBnClickedTexV();
  afx_msg void OnBnClickedTexWrap();
  afx_msg void OnBnClickedTexMirror();
  afx_msg void OnBnClickedTexClamp();
  afx_msg void OnBnClickedTexMirrorOnce();
  afx_msg void OnBnClickedTexBorderColor();
  afx_msg void OnBnClickedTexBorderColorButton();
  afx_msg void OnBnClickedTexBorderAlphaButton();
  afx_msg void OnBnClickedTexFilterMag();
  afx_msg void OnBnClickedTexFilgerMin();
  afx_msg void OnBnClickedTexFilterNone();
  afx_msg void OnBnClickedTexFilterPoint();
  afx_msg void OnBnClickedTexFilterLinear();
  afx_msg void OnBnClickedTexFilterTriangle();
  afx_msg void OnBnClickedTexFilterGaussian();
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
};
