// FogControl.cpp : implementation file
//

#include "stdafx.h"
#include "ClassExampleDlg.h"
#include "FogControl.h"

#include "World.h"

// FogControl dialog

IMPLEMENT_DYNAMIC(FogControl, CDialog)
FogControl::FogControl(CWnd* pParent /*=NULL*/)
	: CDialog(FogControl::IDD, pParent)
  , m_EnableFog(FALSE)
{
}

FogControl::~FogControl()
{
}

void FogControl::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Check(pDX, IDC_ENABLE_FOG, m_EnableFog);
  DDX_Control(pDX, IDC_FOG_NEAR, m_FogNear);
  DDX_Control(pDX, IDC_FOG_FAR,  m_FogFar);
  DDX_Control(pDX, IDC_FOG_DENSITY, m_FogDensity);
}


BEGIN_MESSAGE_MAP(FogControl, CDialog)
  ON_BN_CLICKED(IDC_FOG_COLOR, OnBnClickedFogColor)
  ON_BN_CLICKED(IDC_FOG_LINEAR, OnBnClickedFogLinear)
  ON_BN_CLICKED(IDC_FOG_EXP1, OnBnClickedFogExp1)
  ON_BN_CLICKED(IDC_FOG_EXP2, OnBnClickedFogExp2)
  ON_BN_CLICKED(IDC_ENABLE_FOG, OnBnClickedEnableFog)
  ON_WM_HSCROLL()
END_MESSAGE_MAP()


// FogControl message handlers
// LightControl message handlers
BOOL FogControl::OnInitDialog()
{
		CDialog::OnInitDialog();
    CheckRadioButton(IDC_FOG_LINEAR, IDC_FOG_EXP2, IDC_FOG_LINEAR);
    m_FogNear.Initialize(0.1f, 100.0f, 10.0f);
    m_FogFar.Initialize(1.0f,  500.0f, 20.0f);
    m_FogDensity.Initialize(0.0f, 0.2f, 0.05f);
    OnBnClickedFogLinear();

    return TRUE;
}


void FogControl::OnBnClickedFogColor()
{
  CColorDialog dlg;
	INT_PTR returnValue = dlg.DoModal();
	if (returnValue == IDOK) {
	   COLORREF color = dlg.GetColor();
	   D3DXCOLOR c;
	   c.r = ((color & 0XFF)) / 255.0f;
	   c.g = ((color & 0x00FF00) >> 8) / 255.0f;
	   c.b = ((color & 0xFF0000) >> 16) / 255.0f;
     c.a = 0.0f;
     theWorld.m_FogColor = c;
  }
}

void FogControl::OnBnClickedFogLinear()
{
  theWorld.m_FogMode = D3DFOG_LINEAR;
  m_FogDensity.EnableWindow(FALSE);
  m_FogNear.EnableWindow(TRUE);
  m_FogFar.EnableWindow(TRUE);
}

void FogControl::OnBnClickedFogExp1()
{
  theWorld.m_FogMode = D3DFOG_EXP;
  m_FogDensity.EnableWindow(TRUE);
  m_FogNear.EnableWindow(FALSE);
  m_FogFar.EnableWindow(FALSE);
}

void FogControl::OnBnClickedFogExp2()
{
  theWorld.m_FogMode = D3DFOG_EXP2;
  m_FogDensity.EnableWindow(TRUE);
  m_FogNear.EnableWindow(FALSE);
  m_FogFar.EnableWindow(FALSE);
}

void FogControl::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
 	SliderCtrlWithEcho *pSlider = NULL;
  if (pScrollBar == (CScrollBar *)&m_FogNear) {
    pSlider = &m_FogNear;
    theWorld.m_FogStart = m_FogNear.GetSliderValue();
  }
  else if (pScrollBar == (CScrollBar *)&m_FogFar) {
          pSlider = &m_FogFar;
          theWorld.m_FogEnd = m_FogFar.GetSliderValue();
  }
  else if (pScrollBar == (CScrollBar *)&m_FogDensity) {
              pSlider = &m_FogDensity;
              theWorld.m_FogDensity = m_FogDensity.GetSliderValue();
        }

  if (pSlider == NULL)
    return;

  pSlider->HScroll(nSBCode, nPos);

  

}

void FogControl::OnBnClickedEnableFog()
{
  UpdateData(TRUE);
  theWorld.m_FogEnabled = (this->m_EnableFog == TRUE);
}
