#pragma once


// InteractiveMeshControl dialog

#include "UWB_GraphicsAPI/D3D_4/uwbgl_D3DInteractiveMesh.h"

class InteractiveMeshControl : public CDialog
{
	DECLARE_DYNAMIC(InteractiveMeshControl)

public:
	InteractiveMeshControl(CWnd* pParent = NULL);   // standard constructor
	virtual ~InteractiveMeshControl();

  void SetViewports(D3DViewport *main, D3DViewport *side) { m_MainViewport = main; m_SideViewport = side; }
  void SetInteractiveMesh(int i);

// Dialog Data
	enum { IDD = IDD_INTERACTIVE_MESH_CONTROL };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  virtual BOOL OnInitDialog(); 

  void InitializeControl(int res);
  void InitializeCVPos();



	DECLARE_MESSAGE_MAP()

  InteractiveMesh     *m_InteractiveMesh1, *m_InteractiveMesh2;
  D3DViewport         *m_MainViewport,      *m_SideViewport;

public:
  BOOL m_ShowNormal;
  BOOL m_ShowControlGrid;
  afx_msg void OnBnClickedMeshNormal();
  afx_msg void OnBnClickedControlGrid();
  SliderCtrlWithEcho m_RowSlider;
  SliderCtrlWithEcho m_ColSlider;
  SliderCtrlWithEcho m_PosXSlider;
  SliderCtrlWithEcho m_PosYSlider;
  SliderCtrlWithEcho m_PosZSlider;
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
};

