#pragma once

#include "FileTextureControl.h"

enum ColorSlidersControl
{
		eSliderControlColor = 0,
    eSliderControlEmissive = 1,
    eSliderControlAmbient = 2,
    eSliderControlDiffuse = 3,
    eSliderControlSpecular = 4,
    eSliderControlShingingness = 5
};


// PrimitiveControl dialog

class PrimitiveControl : public CDialog
{
	DECLARE_DYNAMIC(PrimitiveControl)

public:
	PrimitiveControl(CWnd* pParent = NULL);   // standard constructor
	virtual ~PrimitiveControl();

  void SetPrimitive(DrawablePrimitive *p) { m_Primitive = p; PrimitiveSetsControl(); }
  void SetFileTextureControl(FileTextureControl *c) { m_FileTextureControl = c; }

  void PrimitiveSetsControl();

// Dialog Data
	enum { IDD = IDD_PRIMITIVE_CONTROL };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  virtual BOOL OnInitDialog();

  void InitializeRSliderToControlColor();
  void InitializeRSliderToControlShingingness();
  void ColorSlidersSetPrimitive();
  void PrimitiveSetsColorSliders();

  DrawablePrimitive *m_Primitive;
  ColorSlidersControl m_SliderControl;
  FileTextureControl *m_FileTextureControl;

	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg void OnBnClickedTexture();
  afx_msg void OnBnClickedVisibility();
  afx_msg void OnBnClickedShading();
  afx_msg void OnBnClickedBlending();
  afx_msg void OnBnClickedWireFrame();
  afx_msg void OnBnClickedColliders();
  afx_msg void OnBnClickedDrawColor();
  afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
  SliderCtrlWithEcho m_TextureIndex;
  SliderCtrlWithEcho m_ColorR;
  SliderCtrlWithEcho m_ColorG;
  SliderCtrlWithEcho m_ColorB;
  SliderCtrlWithEcho m_ColorA;
  BOOL m_Texture;
  BOOL m_Visibility;
  BOOL m_Shading;
  BOOL m_Blending;
  BOOL m_WireFrame;
  BOOL m_Colliders;
  BOOL m_Lighting;
  BOOL m_Normal;
  afx_msg void OnBnClickedDiffuse();
  afx_msg void OnBnClickedSpecular();
  afx_msg void OnBnClickedAmbient();
  afx_msg void OnBnClickedEmissive();
  afx_msg void OnBnClickedShingingness();
  afx_msg void OnBnClickedLighting();
};
