#pragma once
#include "resource.h"
#include "afxcmn.h"

enum SliderControl
{
  eSliderControlTranslate = 0,
  eSliderControlRotate = 1,
  eSliderControlScale = 2,
  eSliderControlPivot = 3
};


class SceneNodeControl : public CDialog
{
  DECLARE_DYNAMIC(SceneNodeControl)
public:
  SceneNodeControl(CWnd* pParent = NULL);   // standard constructor
  virtual ~SceneNodeControl();

  enum { IDD = IDD_SCENE_NODE_CTRL };

protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  virtual BOOL OnInitDialog();

  SliderControl     m_SliderControl;
  SceneNode        *m_SceneNode;
  D3DXVECTOR3       m_CurrentRotation;

  void ControlSetsSceneNode();
  void InitializeSlidersToTranslate();
  void InitializeSlidersToRotate();
  void InitializeSlidersToScale();
  void InitializeSlidersToPivot();

  DECLARE_MESSAGE_MAP()
public:
  void SetSceneNode(SceneNode *s);
  void SceneNodeSetsControl();
  void ResetSceneNode();

  afx_msg void OnBnClickedTranslate();
  afx_msg void OnBnClickedRotate();
  afx_msg void OnBnClickedScale();
  afx_msg void OnBnClickedPivot();
  afx_msg void OnBnClickedShowPivot();
  afx_msg void OnBnClickedShowAxisFrame();
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
  SliderCtrlWithEcho m_XSlider;
  SliderCtrlWithEcho m_YSlider;
  SliderCtrlWithEcho m_ZSlider;
  BOOL m_ShowPivot;
  BOOL m_ShowAxisFrame;
};