#pragma once
#include "resource.h"
#include "afxcmn.h"
#include "SceneNodeControl.h"
#include "PrimitiveControl.h"
#include "InteractiveMeshControl.h"
#include "FileTextureControl.h"

class SceneTreeDialog : public CDialog
{
  DECLARE_DYNAMIC(SceneTreeDialog)

public:
  SceneTreeDialog(CWnd* pParent = NULL);   // standard constructor
  virtual ~SceneTreeDialog();

  void SetInteractiveMeshControl(InteractiveMeshControl *c) { m_InteractiveMeshControl = c; }
  void SetFileTextureControl(FileTextureControl *c) { m_FileTextureControl = c; m_PrimitiveControl.SetFileTextureControl(c); }

// Dialog Data
  enum { IDD = IDD_SCENETREE };

protected:
  void BuildSceneTree(SceneNode* pNode, HTREEITEM hParentNode = TVI_ROOT);
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

  DECLARE_MESSAGE_MAP()
private:
  CTreeCtrl m_SceneTree;

  class TreeNodeData
  {
  public:
    TreeNodeData()
    : m_pSceneNode(NULL)
    {}

    SceneNode* m_pSceneNode;
  };

  std::vector<TreeNodeData*> m_DataNodes;
  SceneNodeControl m_SceneNodeControl;
  PrimitiveControl m_PrimitiveControl;
  InteractiveMeshControl *m_InteractiveMeshControl;
  FileTextureControl     *m_FileTextureControl;

public:
  virtual BOOL OnInitDialog();
  afx_msg void OnTvnSelchangedSceneTree(NMHDR *pNMHDR, LRESULT *pResult);
};
