// UW Bothell Graphics Library Copyright (c) 2004 University of Washington Bothell
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////
#pragma once

#include "uwbgl_D3DDefines.h"

namespace UWBGL_D3D
{
  struct DeviceVertexFormat
  {
    D3DXVECTOR3  m_Point;   // x,y,z position
    D3DXVECTOR3  m_Normal;   // normal vector at vertex position
    D3DCOLOR     m_Color;    // color for vertex
    FLOAT        m_U,  m_V;  // stage 0 texture coordinates
    FLOAT        m_U1, m_V1; // stage 1 texture coordinates
  };


  #define DeviceVertexFormatCode (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_DIFFUSE|D3DFVF_TEX2)

  // FVF flags D3DFVF_XXXX where XXXX is one of the following ...
  // vertices:  (XYZ - three floats)
  //            XYZ - untransformed vertex (WILL go through transformation stack)
  // color: DWORD (4 shorts)
  //        DIFFUSE
  // texture: 2 sets of 2 floats to support two stage multitexturing, 
  //          we need to have two sets of texture coordinate per Vertex
  // TEX2: says two sets of texture coordinate are presented		
};
