#pragma once

#include "uwbgl_D3DDefines.h"
#include "uwbgl_D3DXFormInfo.h"

namespace UWBGL_D3D
{

#define eFileTexture_UAddress 0
#define eFileTexture_VAddress 1

#define eFileTexture_MinFilter 0
#define eFileTexture_MagFilter 1

	class FileTexture
	{
		protected:
			LPDIRECT3DTEXTURE9	m_Texture;
			LPDIRECT3DDEVICE9		m_D3dDevice;

		public:
			FileTexture(LPDIRECT3DDEVICE9 pd3dDevice, const char* filename);
			~FileTexture();

			void ActivateTexture(DWORD stage=0);
			void DeActivateTexture(DWORD stage=0);
			BOOL CreateD3DTexture(LPDIRECT3DDEVICE9 pd3dDevice, const char* filename);

			LPDIRECT3DTEXTURE9 GetTexture() { return m_Texture; }


      //
      // 1. Placement support 
      float     m_TexRotate, m_TexTransX, m_TexTransY, m_TexScaleX, m_TexScaleY;

      // 2. UV Addressing
      DWORD         m_UVAddr[2];    // U is index 0, and V is index 1
      D3DXCOLOR     m_BorderColor;  // if address is border ...

      // 3. Mag/Min filtering
      DWORD         m_Filter[2];    // Min is index 0, and Mag is index 1
	};
}