#include "uwbgl_D3DGraphicsSystem.h"
#include "uwbgl_D3DDeviceVertexFormat.h"
#include "uwbgl_D3DInteractiveMesh.h"
#include "uwbgl_D3DInteractiveMeshPrimitive.h"
#include "uwbgl_D3DCollider.h"

using namespace UWBGL_D3D;


void InteractiveMeshPrimitive::GetColliderList(ColliderList &list) 
{
	//
	// For now, assume the mesh is of size 1.0, located at the origin
  Collider c(D3DXVECTOR3(0.0f, 0.0f, 0.0f), 1.0f);
  list.Append(c);
}

void InteractiveMeshPrimitive::DrawPrimitiveGeometry()
{
	LPDIRECT3DDEVICE9 d3dDevice = GraphicsSystem::GetSystem().GetActiveDevice();
  if (d3dDevice == NULL) return;

  ID3DXMatrixStack* pStack =  GraphicsSystem::GetSystem().GetWorldStack();
  pStack->Push();

      m_XForm.SetUpD3DXformStack( pStack );
      d3dDevice->SetTransform(D3DTS_WORLD,pStack->GetTop());

        ResourceTable *t = GraphicsSystem::GetSystem().GetActiveResourceTable();
        if (t != NULL) 
        {
            InteractiveMesh *m = (InteractiveMesh *) ((*t)[m_MeshIndex]);
            if (m != NULL)
                m->DrawMesh(!LightingIsEnabled(), m_DrawColor);
        }
  pStack->Pop();
  d3dDevice->SetTransform(D3DTS_WORLD,pStack->GetTop());
}
