#pragma once

#include "uwbgl_D3DDefines.h"

namespace UWBGL_D3D
{

    //
    //****************************************************************************************************
    // Copied and massage from DXSDK 9: D3D Tutorial 6 on mesh
    //  
    // Date: Jan 2003
    // By: Kelvin Sung
    //

    class RawMesh {
      
      private:
        LPD3DXMESH              m_Mesh;           // Our mesh object in sysmem
        D3DMATERIAL9*           m_MeshMaterials;  // Materials for our mesh
        LPDIRECT3DTEXTURE9*     m_MeshTextures;   // Textures for our mesh
        unsigned long           m_NumMaterials;   // Number of mesh materials
        LPDIRECT3DDEVICE9       m_Device;         // Which device will store this mesh

        ID3DXMatrixStack*		    m_Stack;			// For scaling object size/location to norm

		    D3DXVECTOR3				      m_ObjectCenter;        // Center of bounding sphere of object
		    FLOAT					          m_ObjectRadius;        // Radius of bounding sphere of object

        void ReleaseMemory();
      
      public:

        RawMesh();
        ~RawMesh();

        HRESULT   LoadMesh(LPDIRECT3DDEVICE9, ID3DXMatrixStack* stack, const char* path, const char* fileName);
        VOID      DrawNormalizedMesh(bool useColor, bool shouldTexture, const D3DXCOLOR &c, const D3DMATERIAL9 *useM=NULL);
        VOID      DrawOriginalSizeMesh(bool useColor, bool shouldTexture, const D3DXCOLOR &c, const D3DMATERIAL9 *useM=NULL);
        float     MeshRadius() { return m_ObjectRadius; }
        const D3DXVECTOR3& MeshCenter() const { return m_ObjectCenter; }
    };

}