// UW Bothell Graphics Library Copyright (c) 2004 University of Washington Bothell
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_D3DDefines.h"
#include "../uwbgl_ViewportBase.h"
#include "uwbgl_D3DFileTexture.h"
#include "uwbgl_D3DCamera.h"

namespace UWBGL_D3D
{
  class D3DViewport : public ViewportBase
  {
  public:
    D3DViewport();
    virtual ~D3DViewport();

    virtual bool GraphicsDeviceReady();
    virtual bool CreateGraphicsDevice(HWND parentWindow);
    virtual void InitializeDeviceForDrawing();
    virtual void RestoreDeviceAfterDrawing();

    void SetBackgroundColor(float red, float green, float blue);

    ResourceTable*  GetResourceTable() { return &m_ResourceTable; }

    Camera m_Camera;
  protected:
    D3DPRESENT_PARAMETERS m_D3Dpp;  // This is the D3D device description
    LPDIRECT3DDEVICE9 m_pD3DDevice; // This is the abstract link to the D3D Device (Window)
    D3DCOLOR m_BackgroundColor;     // This is the background color

    //************************ Resource support ***********************
    void InitializeResourceTable();
    void ClearResourceTable();
    ResourceTable m_ResourceTable;
    //**********************************************************************
  };
};