// UW Bothell Graphics Library Copyright (c) 2004 University of Washington Bothell
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////

// uwbgl_defines.h: Common preprocessor symbols and macros used by the Graphics Library.
#pragma once

#ifndef M_PI
  #define M_PI 3.14159265358979323846f
#endif

#ifndef M_VERY_LARGE 
  #define M_VERY_LARGE 999999999.0f
  #define M_VERY_SMALL -M_VERY_LARGE
#endif



#define UWBGL_EXTERNC extern "C"
#define UWBGL_BEGIN_EXTERNC extern "C" {
#define UWBGL_END_EXTERNC   }

//If the library is compiled as a DLL, we need to declare which classes
//and functions are publically exposed
#if defined(UWBGL_DLL_EXPORTS)
  // When compiling as a DLL, export classes, functions, templates, and globals
  #define UWBGL_CLASS __declspec(dllexport)
  #define UWBGL_DECL __declspec(dllexport)
  #define UWBGL_DEFN
  #define UWBGL_EXTERN_DECL extern __declspec(dllexport)
  #define UWBGL_EXTERN_DEFN
  #define UWBGL_TEMPLATE

#elif defined(UWBGL_DLL_IMPORTS)
  // When an application is using this library as a DLL, allow the application to import definitions
  #define UWBGL_CLASS __declspec(dllimport)
  #define UWBGL_DECL __declspec(dllimport)
  #define UWBGL_DEFN
  #define UWBGL_EXTERN_DECL extern __declspec(dllimport)
  #define UWBGL_EXTERN_DEFN
  #define UWBGL_TEMPLATE extern

#else
  // We are compiling as a library that will be staticly linked into our project
  #define UWBGL_CLASS
  #define UWBGL_DECL
  #define UWBGL_DEFN
  #define UWBGL_EXTERN_DECL extern
  #define UWBGL_EXTERN_DEFN
  #define UWBGL_TEMPLATE

#endif



#ifndef VC_EXTRALEAN
  #define VC_EXTRALEAN          // Exclude rarely-used stuff from Windows headers
#endif
#ifndef WINVER                  // Allow features specific to Win95 and WinNT 4 or later.
  #define WINVER 0x0400         // Change to target later windows versions.
#endif
#ifndef _WIN32_WINNT            // Allow features specific to WinNT 4 or later.
  #define _WIN32_WINNT 0x0400   // Change to target later WinNT versions.
#endif						
#ifndef _WIN32_WINDOWS          // Allow features specific to Windows 98 or later.
  #define _WIN32_WINDOWS 0x0410 // Change to target Windows Me or later.
#endif
#ifndef _WIN32_IE               // Allow features specific to IE 4.0 or later.
  #define _WIN32_IE 0x0400      // Change to target IE 5.0 or later.
#endif

#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS // some CString constructors will be explicit
#include "Windows.h"
