// UW Bothell Graphics Library Copyright (c) 2004 University of Washington Bothell
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////

// uwbgl_MFC.h: Main header for including the MFC support windows classes
// The following header files and preprocessor definitions bring in support for
// base MFC classes that this library uses and subclasses from.
#pragma once

#define WIN32_LEAN_AND_MEAN                 // Exclude rarely-used stuff from Windows headers
#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS  // some CString constructors will be explicit

#ifndef WINVER
  #define WINVER 0x400
#endif

#ifndef VC_EXTRALEAN
  #define VC_EXTRALEAN                      // Exclude rarely-used stuff from Windows headers
#endif

#include <afx.h>
#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions

#include <afxdtctl.h>       // MFC support for Internet Explorer 4 Common Controls
#ifndef _AFX_NO_AFXCMN_SUPPORT
  #include <afxcmn.h>       // MFC support for Windows Common Controls
#endif


//By including our library headers in this single header file, all we have to do in
//actual projects is include this single header file. This is a standard we to provide
//library support to external projects.
#include "uwbgl_MFCUIWindow.h"
#include "uwbgl_MFCSliderCtrlWithEcho.h"

//MFC Utility Functions.
namespace UWBGL_MFC
{
  //Replace a control defined with the resource editor with a "sub"-dialog. This provides fro
  //generating re-usable control panels
  void LinkControlToPlaceHolder(CWnd* pDlg, UINT idcPlaceHolderName, UINT controlTag, CDialog *control);
};

using namespace UWBGL_MFC;