// UW Bothell Graphics Library Copyright (c) 2004 University of Washington Bothell
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////

/// uwbgl_MFCUtilityFunctions.cpp: implementation file for uwbgl_MFC.h header. Library_v01
///
#include "uwbgl_MFC.h"

#ifdef _DEBUG
  #define new DEBUG_NEW
#endif

/// This function receives our placeholder resource and destroys/replaces it 
/// with the specified Dialog control resource
/// \param pDlg	Pointer to the current CDialog window, i.e., this
/// \param idcPlaceHolderName	Control ID for the placeholder resource
/// \param controlTag	Control ID for the D3D-capable Dialog window
/// \param control	Pointer to the active CDialog object, i.e., &m_ReplcmntDlgCtrl
void UWBGL_MFC::LinkControlToPlaceHolder(CWnd* pDlg, UINT idcPlaceHolderName, UINT controlTag, CDialog *control)
{
  // a. use idcPlaceHolder to figure out on-screen area for replacement window
  CWnd* pStatic = pDlg->GetDlgItem(idcPlaceHolderName);
  CRect staticRect;
  pStatic->GetWindowRect(&staticRect);
  pDlg->ScreenToClient(&staticRect);

  // b. just hide the place holder window in case we need to reuse it
  pStatic->ShowWindow(SW_HIDE);
  
  // convert the static's screen rectangle to the dialog's client coordinates
  const CPoint &topLeft = staticRect.TopLeft();
  if ( !control->Create(controlTag, pDlg) ) pDlg->MessageBox("Creation of control Dialog Failed!!");

  control->MoveWindow(topLeft.x,topLeft.y,staticRect.Width(),staticRect.Height());
  control->BringWindowToTop();
  control->ShowWindow(SW_SHOWDEFAULT);
  control->UpdateWindow();
}
