#pragma once

class World
{
public:
  World();

  void Reset();

  void DrawWorld();
  void UpdateWorld();

  void ShowMainCamera(bool on) {m_bMainCameraVisible = on; }
  bool IsMainCameraVisible() const { return m_bMainCameraVisible; }
  void ShowMainCameraRail(bool on) {m_bMainCameraRailVisible = on; }
  bool IsMainCameraRailVisible() const { return m_bMainCameraRailVisible; }

  void SetMoveTiger(bool on);
  SceneNode* GetRootNode();

	Light*		GetSpotLight() { return &m_SpotLight; }
	Light*		GetDirectionalLight() { return &m_DirectionalLight; }
	Light*		GetPointLight() { return &m_PointLight; }


  // Fog Support
  bool            m_FogEnabled;
  D3DXCOLOR       m_FogColor;
  DWORD           m_FogMode;
  float           m_FogStart;
  float           m_FogEnd;
  float           m_FogDensity;

private:
  
  PointLight        m_PointLight;
  DirectionalLight  m_DirectionalLight;
  SpotLight         m_SpotLight;

  //SceneNode structure for this world
  // m_RootNode
  //   |- m_pTigerNode
  //   |      - m_TigerPrimitive
  //   |- m_pCircleNode
  //   |      - m_CirclePrimitive
  //   |- m_pCraftNode
  //          - m_CraftPrimitive
  SceneNode  m_RootNode;
  SceneNode* m_pTigerNode;
  SceneNode* m_pCircleNode;
  SceneNode* m_pCraftNode;
  SceneNode* m_pFloorNode;
  SceneNode* m_pTeapotNode;

  bool m_bMoveTiger;
  bool m_bMainCameraVisible;
  bool m_bMainCameraRailVisible;

  void DoFog();
};

extern World theWorld;
