#include "StdAfx.h"
#include "World.h"

#ifdef _DEBUG
  #define new DEBUG_NEW
#endif

void World::DoFog()
{
  LPDIRECT3DDEVICE9 device = GraphicsSystem::GetSystem().GetActiveDevice();
	if (device == NULL) return;

  device->SetRenderState(D3DRS_FOGENABLE, FALSE);

  if (!m_FogEnabled) {
		return;
  }

	D3DCOLOR fogColor = D3DCOLOR_COLORVALUE( m_FogColor.r, m_FogColor.g, m_FogColor.b, m_FogColor.a);
	
	// Enable fog blending.
  device->SetRenderState(D3DRS_FOGENABLE, TRUE);
		 
  // Set the fog color.
  device->SetRenderState(D3DRS_FOGCOLOR, fogColor);
				     
    // Set fog mode parameters.
	device->SetRenderState(D3DRS_FOGTABLEMODE, m_FogMode);
	
  if( m_FogMode == D3DFOG_LINEAR ) {
		device->SetRenderState(D3DRS_FOGSTART, *(DWORD *)(&m_FogStart));
		device->SetRenderState(D3DRS_FOGEND,   *(DWORD *)(&m_FogEnd));
	} else {
		device->SetRenderState(D3DRS_FOGDENSITY, *(DWORD *)(&m_FogDensity));
  }
}